Ruby - Bug #19048

Install of Ruby 3.1.x fails on Ubuntu 20.04 running on WSL
10/11/2022 01:39 PM - NickGrahamDfE (Nick Graham)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: Backport: 2.7: UNKNOWN, 3.0: UNKNOWN, 3.1:
UNKNOWN

Description

History

#1 - 10/11/2022 01:45 PM - NickGrahamDfE (Nick Graham)

Attempting to install Ruby 3.1.x fails when executed with asdf install ruby 3.1.2 or rbenv install 3.1.2. Attempts to install 3.1.0 and 3.1.1 also fail.
3.0.3 and 3.2.0-preview2 succeed. rbenv and all elements of ruby were uninstalled before attempting to install with asdf. The error messages
discussed below are the same for both the asdf and rbenv installs.

The output from the install is BUILD FAILED (Ubuntu 20.04 using ruby-build 20221004) and the logs show this

Building native extensions. This could take a while...
/tmp/ruby-build.20221011135449.3126.agFWSF/ruby-3.1.2/1ib/rubygems/ext/builder.rb:95:in ‘run': ERROR: Failed t
o build gem native extension. (Gem::Ext::BuildError)

current directory: /home/ubadmin/.asdf/installs/ruby/3.1.2/1lib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rbs_exte
nsion
/home/ubadmin/.asdf/installs/ruby/3.1.2/bin/ruby —--disable\\=gems —-I/home/ubadmin/.asdf/installs/ruby/3.1.2/11i
b/ruby/3.1.0/x86_64-1linux —-I /tmp/ruby-build.20221011135449.3126.agFWSF/ruby-3.1.2/1ib -r ./siteconf20221011-1
6881-tbjk7g.rb extconf.rb
creating Makefile

current directory: /home/ubadmin/.asdf/installs/ruby/3.1.2/1ib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rbs_extensio
n

make DESTDIR\\= clean

make[1l]: Entering directory '/home/ubadmin/.asdf/installs/ruby/3.1.2/1ib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rb
s_extension'

make[l]: Leaving directory '/home/ubadmin/.asdf/installs/ruby/3.1.2/1lib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rbs
extension'

current directory: /home/ubadmin/.asdf/installs/ruby/3.1.2/1ib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rbs_extensio
n

make DESTDIR\\=

make[l]: Entering directory '/home/ubadmin/.asdf/installs/ruby/3.1.2/1ib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rb
s_extension'

compiling constants.c

as: error while loading shared libraries: libcrypt.so.l: cannot open shared object file: No such file or direc

tory

make[1l]: *** [Makefile:246: constants.o] Error 1

make[l]: Leaving directory '/home/ubadmin/.asdf/installs/ruby/3.1.2/1lib/ruby/gems/3.1.0/gems/rbs-2.1.0/ext/rbs
extension'

make failed, exit code 2
I'm able to install the rbs gem successfully though using gem install rbs -v 2.1.0

#2 - 10/12/2022 12:09 PM - mame (Yusuke Endoh)

as: error while loading shared libraries: libcrypt.so.l: cannot open shared object file: No such file or direc
tory

This seems to be the cause, but | don't know why it's happening.
| write down what | can think of:

e Can you invoke as command? Does as --version work?
* Have you installed binutils with asdf or similar?
o |s there /lib/x86_64-linux-gnu/libcrypt.so.1?
e What happens if you do apt-get install libcrypt1?

#3 - 10/13/2022 08:06 AM - NickGrahamDfE (Nick Graham)

e Can you invoke as command? Does as --version work? Yes, it returns:
GNU assembler (GNU Binutils) 2.39
[removed copyright text]
This assembler was configured for a target of "x86_64-pc-linux-gnu'.
® Have you installed binutils with asdf or similar? It's installed with brew as well as the automatic apt install
apt list binutils returns binutils/focal-updates,focal-security,now 2.34-6ubuntu1.3 amd64 [installed,automatic]
brew list binutils returns /home/linuxbrew/.linuxbrew/Cellar/binutils/2.39_1
it doesn't look like | can remove the brew installed version as many things are dependent on it
e |s there /lib/x86_64-linux-gnu/libcrypt.s0.1? Yes, it's a symbolic link to libcrypt.so.1.1.0
¢ What happens if you do apt-get install libcrypt1?

libcryptl is already the newest version (1:4.4.10-10ubuntu4).
0 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.

#4 - 11/10/2022 06:00 AM - masa-iwasaki (Masatoshi Iwasaki)
| faced the same error and succeeded to build 3.1.2 by following steps.
e Uninstall rbenv & ruby-build if you have already installed them with linuxbrew
¢ Disable linuxbrew temporally
¢ Install rbenv & ruby-build by git clone
® Run rbenv install 3.1.2
You can disable linuxbrew by commenting out the configuration like below in your doffiles.

# eval "$(/home/linuxbrew/.linuxbrew/bin/brew shellenv)"

It seems that linuxbrew has some problems with libcrypt.so.1. You can find them in GitHub Discussions of homebrew.
https://github.com/orgs/Homebrew/discussions?discussions_qg=libcrypt.so.1

#5 - 04/03/2024 05:45 AM - hsbt (Hiroshi SHIBATA)
- Status changed from Open to Closed

Closing due to lack of feedback over 1 year.
